---
title: Boilerplate Jekyll How-to
layout: post
date: '2025-05-01 12:00:00 +0000'
categories:
- jekyll
tags:
- getting-started
---

# Welcome to Jekyll!

This is your first post using Jekyll with the less-style theme. Jekyll is a static site generator that transforms your plain text into static websites and blogs.

## How to Create Posts

To create a new post, simply add a file in the `_posts` directory that follows the naming convention `YYYY-MM-DD-title.md`, where `YYYY-MM-DD` is the date of your post and `title` is the title of your post.

At the top of each post, you need to include what's called "front matter" - this is YAML that tells Jekyll how to process the file. Here's an example:

```yaml
---
layout: post
title: "Your Post Title"
date: 2023-05-01 12:00:00 -0000
categories: [category1, category2]
tags: [tag1, tag2]
---
```

## Markdown Formatting

Jekyll uses Markdown for formatting. Here are some examples:

### Headers

```markdown
# H1
## H2
### H3
```

### Emphasis

```markdown
*italic* or _italic_
**bold** or __bold__
```

### Lists

```markdown
- Item 1
- Item 2
  - Subitem 2.1
  - Subitem 2.2

1. First item
2. Second item
```

### Links and Images

```markdown
[Link text](URL)
![Image alt text](image-url)
```

### Code

```markdown
`inline code`

```python
# Code block with syntax highlighting
def hello_world():
    print("Hello, world!")
```
```

## Next Steps

1. Customize your site by editing `_config.yml`
2. Create new posts in the `_posts` directory
3. Add pages by creating new markdown files in the root directory
4. Customize the theme by overriding CSS in `assets/css/style.scss`

Happy blogging with Jekyll!
